# python daemon starter script
# based on skeleton from Debian GNU/Linux
# cliechti@gmx.net
#
# this daemon scripts runs NOT as root - so start it as the gameserver user
#

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=$PWD/cod_controld.py
NAME=cod_controld
DESC="Gameserver control daemon"

test -f $DAEMON || exit 0

set -e

case "$1" in
  start)
	echo "Starting $DESC: "
	start-stop-daemon --start --quiet --pidfile $PWD/$NAME.pid \
		--exec $DAEMON
	echo "$NAME started."
	;;
  stop)
	echo "Stopping $DESC: "
	start-stop-daemon --stop --quiet --pidfile $PWD/$NAME.pid
	rm $PWD/$NAME.pid
	echo "$NAME stoped."
	;;
  restart)
	echo "Restarting $DESC: "
	start-stop-daemon --stop --quiet --pidfile \
		$PWD/$NAME.pid
	rm $PWD/$NAME.pid
	sleep 1
	start-stop-daemon --start --quiet --pidfile \
		$PWD/$NAME.pid --exec $DAEMON
	echo "$NAME restarted."
	;;
  *)
	N=$NAME
	echo "Usage: $N {start|stop|restart}" >&2
	exit 1
	;;
esac

exit 0