#!/usr/bin/env python
# -*- encoding: latin1 -*-

#
#    web control interface daemon  
#    by Gunnar Luehr 2008 under the
#    GNU General Public License
#    V 0.0.2 (17.02.2008)
#
#    admin@masterzock.de
#    http://www.masterzock.de
#------------------------------------------------------------------------------
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
# -----------------------------------------------------------------------------
#
# cod_controld.py
#


# -----------------------------------------------------------------------------
# 
#         config  start


# the password
PWORD = ''

# allowed servers - you can add more if you like
ALLOWED_SVR=["cod2_lncded", "cod4_lnxded"]

# allowed ip to access - "0.0.0.0" = allow all (not secure!)
ALLOWED_IP=["127.0.0.1"]

# the network port
NET_PORT = 4100

# the log file - use the absolut path!!
LOGFILE = 'cod_controld.log'

# log type:  2=less | 1=normal | 0=debug
LOGTYPE = 1

# OpenSSL PEM File for encryption the data - use the absolut path!!
PEMFILE = 'server.pem'

# Encryption type:  1=tls | 2=ssl V2 or V3 depending on client php version
ENCTYPE = 1

# the linux PID file - use the absolut path!
PIDFILE = 'cod_controld.pid'

# screen pid files - normaly no changes neede (debian) - use the absolut path!
SCREEN_PID = '/var/run/screen'

#         config  end
#
#-----------------------------------------------------------------------------



#
#
#
#------------------------------------------------------------------------------
#
#
# DO NO EDITING BEHIND THIS UNTIL YOU KNOW WHAT YOU ARE DOING !!
#
#  
#------------------------------------------------------------------------------
#
#
#




#
# import
#
import sys, os , SocketServer, socket, time, string, pwd, signal
from OpenSSL import SSL


#
# some init stuff
#
BUFSIZE = 1024
UNAME   = pwd.getpwuid(os.getuid())[0]

#
# log all output and flush it so that everything will loged 
#
class Log:
    def __init__(self, f):
        self.f = f
    def write(self, s):
        self.f.write(s)
        self.f.flush()
#
# log
#
def mylog(entry, type):
    if type >= LOGTYPE:
        print time.strftime("[%Y.%m.%d %H:%M:%S] ") + entry

#
# sigterm - server shutdown
#
def on_signal(signum, frame):
    mylog('SIGTERM - Server shutdown', 2)
    sys.exit(0)

#
# main server routin
#
def main():
    # root not allowed
    if os.getuid() == 0:
        mylog('SORRY! THIS DAEMON RUNS NOT AS ROOT - ABORTING', 2)
        
    else:
        # Create TCP-Socket Server
        mylog('Creating Server on port: %s' % NET_PORT, 2) 
        
        class SecureThreadingRequestHandler(SocketServer.StreamRequestHandler):
            def setup(self):
                #self.connection = self.request # for doPOST
                self.rfile = socket._fileobject(self.request, "rb", self.rbufsize)
                self.wfile = socket._fileobject(self.request, "wb", self.wbufsize)

            # connection from client
            def handle(self):
                client_id = str(self.client_address[0])
                IP_OK   = 0
                # check if ip is in ALLOWED_IP
                for ips in ALLOWED_IP:
                    if client_id == ips:
                        IP_OK = 1
                        break
                    elif ips == '0.0.0.0':
                        IP_OK = 1
                        break                    
                
                # check if only localhost is allow
                if IP_OK:
                    if client_id != '127.0.0.1':
                        mylog('Connection from: '+client_id, 2) 

                    # check pw
                    data = self.rfile.readline().strip()
                    if data==PWORD:
                        if client_id != '127.0.0.1':
                            mylog('OK LOGIN BY CLIENT: '+client_id, 0)
                        self.wfile.write('[WELCOME]\r\n')
                        
                        while 1:
                            # command from the client
                            data = self.rfile.readline().strip().upper()
                            # disconnect by client
                            if data == "EXIT":
                                if client_id != '127.0.0.1':
                                    mylog('EXIT CMD BY CLIENT: '+client_id, 2)
                                self.wfile.write('[GOODBY]\r\n')
                                self.request.close()  
                                break
                                
                            # the client would like to start a server
                            elif data == "START":
                                mylog('START CMD FROM CLIENT: '+client_id, 0) 
                                self.wfile.write('[START]\r\n')        

                                # server name for screen daemon
                                SVR_NAME = self.rfile.readline().strip()
                                if len(SVR_NAME)==0:
                                    mylog('ERROR - NEED NAME TO START DAEMON '+client_id, 1)
                                    self.wfile.write('[ERROR_NEED_SVR_NAME]\r\n')
                                    break
                                else:
                                    # check if a screen with the same name exists
                                    br=0
                                    screen_dir = os.listdir(SCREEN_PID+'/S-'+UNAME)
                                    for x in screen_dir:
                                        if x.count(SVR_NAME):
                                            mylog('ERROR - DAEMON NAME: '+SVR_NAME+' ALREADY EXISTS! '+client_id, 1) 
                                            br = 1
                                    if br==0:
                                        self.wfile.write('[SERVER_NAME]'+SVR_NAME+'\r\n')
                                    else:
                                        self.wfile.write('ERROR_DAEMON_ALREADY_EXISTS] '+SVR_NAME+' \r\n')
                                        break
        
                                # path to the server file
                                SVR_PATH = self.rfile.readline().strip()
                                if len(SVR_PATH)==0:
                                    mylog('ERROR - NEED PATH TO START DAEMON'+client_id, 1)
                                    self.wfile.write('[ERROR_NEED_SVR_PATH]\r\n')
                                    break
                                else:
                                    self.wfile.write('[PATH]'+SVR_PATH+'\r\n')                            
        
                                # the server executable file 
                                SVR_FILE = self.rfile.readline().strip()
                                if len(SVR_FILE)==0:
                                    mylog('ERROR - NEED SERVER NAME TO START DAEMON s'+client_id, 1)
                                    self.wfile.write('[ERROR_NEED_SVR_EXEC]\r\n')
                                    break
                                else:
                                    br=0
                                    # ok server exec is ok
                                    for sv in ALLOWED_SVR:
                                        if sv==SVR_FILE:
                                            self.wfile.write('[SERVER_EXEC]'+SVR_FILE+'\r\n')
                                            br=1
                                            
                                    # server exec not allowed - byby
                                    if br==0:
                                        mylog('ERROR server executeable: '+SVR_FILE+' is not allowed '+client_id, 1) 
                                        self.wfile.write('ERROR_SVR_EXEC_NOT_ALLOWED]'+SVR_FILE+'\r\n')
                                        break
        
                                # options for server start - could be empty
                                SVR_OPTIONS = self.rfile.readline().strip()
                                self.wfile.write('[SERVER_OPTIONS]'+SVR_OPTIONS+'\r\n')                        
                                
                                # everything complete! lets start the screen daemon
                                os.system('cd '+SVR_PATH+'; screen -dmS '+ SVR_NAME+' '+SVR_PATH+'/'+SVR_FILE+' '+SVR_OPTIONS)
                                time.sleep(0.1)
    
                                # check if a screen with the same name exists
                                br=0
                                screen_dir = os.listdir(SCREEN_PID+'/S-'+UNAME)
                                for x in screen_dir:
                                    if x.count(SVR_NAME):
                                        pid = str(x.split('.')[0])
                                        mylog('SERVER STARTED WITH PID: '+ pid +' FOR: '+client_id, 1) 
                                        self.wfile.write('[SERVER_STARTED]\r\n')
                                        br=1
                                        
                                # server not startet
                                if br==0:    
                                    mylog('ERROR - SERVER NOT STARTED! '+client_id, 1) 
                                    self.wfile.write('[ERROR_SVR_NOT_STARTED]\r\n')
                                #break
                                                       
        
                            # the client would like to stop a server
                            elif data == "STOP":
                                mylog('STOP command from client: '+client_id, 0)
                                self.wfile.write('[STOP]\r\n')
                                SVR_NAME = self.rfile.readline().strip()
                                br=0
                                screen_dir = os.listdir(SCREEN_PID+'/S-'+UNAME)
                                for x in screen_dir:
                                    if x.count(SVR_NAME):
                                        pid = str(x.split('.')[0])
                                        mylog('SERVER STOPED WITH PID: '+ pid +' FOR: '+client_id, 1) 
                                        os.system('kill -9 '+pid+' > /dev/null')
                                        os.system('screen -wipe > /dev/null')
                                        self.wfile.write('[SERVER_STOPED]'+SVR_NAME+'\r\n')                                        
                                        br=1
                                        break
                                if br==0:    
                                    mylog('ERROR - SERVER NOT STOPED! WRONG NAME?'+client_id, 1) 
                                    self.wfile.write('[ERROR_SVR_NOT_STOPED]\r\n')
                                #break

        
                            # the client would like to get the server status
                            elif data == "STATUS":
                                mylog('STATUS command from client: '+client_id, 0)
                                self.wfile.write('[STATUS]\r\n')
                                SVR_NAME = self.rfile.readline().strip()
                                br=0
                                screen_dir = os.listdir(SCREEN_PID+'/S-'+UNAME)
                                for x in screen_dir:
                                    if x.count(SVR_NAME):
                                        pid = str(x.split('.')[0])
                                        mylog('OK - SERVER WITH PID: '+pid+' AND NAME: '+SVR_NAME+' RUNNING '+client_id, 1) 
                                        self.wfile.write('[SERVER_RUNNING]'+SVR_NAME+'\r\n')
                                        br=1
                                        break
                                if br==0:    
                                    mylog('ERROR - server not running ! Wrong name? '+client_id, 1) 
                                    self.wfile.write('[ERROR_NOT_RUNNING]'+SVR_NAME+'\r\n')

                            # wrong or unknown command
                            else:
                                mylog('ERROR - WRONG CMD:'+ data +' FROM: '+client_id, 2) 
                                self.wfile.write('[ERROR_WRONG_CMD]'+data+'\r\n')

                        # request end
                        self.request.close()

                    # wrong pw
                    else:
                        mylog('WARNING - WRONG PW BY CLIENT:'+client_id, 2)

                # connection from none allowed client (only localhost allowed here))
                else:
                    mylog('WARNING - NONE ALLOWED CONNECTION FROM: '+client_id, 2)
    

        #
        # start the server
        #

        #
        #   ssl support for connection
        #
        
        class SecureTCPServer(SocketServer.ThreadingTCPServer):
            def __init__(self, server_address, RequestHandlerClass):
                SocketServer.BaseServer.__init__(self, server_address, RequestHandlerClass)
        
                # Same as normal, but make it secure:
                if ENCTYPE == 1:
                    ctx = SSL.Context(SSL.TLSv1_METHOD)
                elif ENTYPE == 2:
                    ctx = SSL.Context(SSL.SSLv23_METHOD)
                else:
                    ctx = SSL.Context(SSL.SSLv23_METHOD)
                    
                ctx.set_options(SSL.OP_NO_SSLv2)
        
                dir = os.curdir
                ctx.use_privatekey_file (PEMFILE)
                ctx.use_certificate_file(PEMFILE)

                self.socket = SSL.Connection(ctx, socket.socket(self.address_family,self.socket_type))
                self.server_bind()
                self.server_activate()

        class SecureThreadingServer(SocketServer.ThreadingTCPServer, SecureTCPServer):
            def __init__(self, addr,
                         requestHandler=SecureThreadingRequestHandler,
                         logRequests=1):
                self.funcs = {}
                self.logRequests = logRequests
                self.instance = None
                SecureTCPServer.__init__(self, addr, requestHandler)
        
        
        dispatcher = SecureThreadingServer(('', NET_PORT), SecureThreadingRequestHandler)
        mylog('listening on: %s' % NET_PORT, 2)
        dispatcher.serve_forever()



#
# daemonize the server
#
if __name__ == "__main__":

    # redirect all outputs to log file
    sys.stdout = Log(open(LOGFILE, 'a+'))
    sys.stderr = Log(open(LOGFILE, 'a+'))
 

    # forck the process from the shell
    try: 
        pid = os.fork() 
        if pid > 0:
            # exit first parent
            sys.exit(0) 
    except OSError, e: 
        print >>sys.stderr, time.strftime("[%Y.%m.%d %H:%M:%S] ") + "fork #1 failed: %d (%s)" % (e.errno, e.strerror) 
        sys.exit(1)

    # secound parent environment
    os.chdir("/") 
    os.setsid() 
    os.umask(0) 

    # do second fork
    try: 
        pid = os.fork() 
        if pid > 0:
            # exit from second parent, print eventual PID before
            print time.strftime("[%Y.%m.%d %H:%M:%S] ") + "Daemon PID %d" % pid 
            open(PIDFILE,'w').write("%d"%pid)
            sys.exit(0) 
    except OSError, e: 
        print >>sys.stderr, time.strftime("[%Y.%m.%d %H:%M:%S] ") + "fork #2 failed: %d (%s)" % (e.errno, e.strerror) 
        sys.exit(1) 

    #
    # start daemon main loop - server
    #
    signal.signal(signal.SIGTERM, on_signal)    
    main()
