<?php
/*------------------------------------------------------------------------------
 *    web control interface for cod_control  
 *    by Gunnar Luehr 2008 under the
 *    GNU General Public License
 *    V 0.0.2 (17.02.2008) 
 *    admin@masterzock.de
 *    http://www.masterzock.de
 *------------------------------------------------------------------------------
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 * -----------------------------------------------------------------------------
 *  
 *  index.php
 *
 *  main routins for the start,stop and status
 * 
 */     

session_start();

include_once "config.php";
include "lng/".$sel_lng.".php";


//
// clear new line and cr from string
//
function clnl($in)
  {
  $out = str_replace(array("\n","\r"), "", $in);
  return $out;
  }

//
// get the status off all reg. servers
//
function get_status_all()
  {
  global $game_svr, $lng, $encrypt;
    foreach ($game_svr as $key => $con)
      {
      $con[fopen] = @fsockopen($encrypt."://".$con[ip], $con[port], $errno, $errstr, 30);
      if ($con[fopen])
        {
        $wr = fwrite($con[fopen], $con[pass]."\n");
        $re =  clnl(@@fgets($con[fopen]));
        if ($re=="[WELCOME]")
          {
          $wr = fwrite($con[fopen], "status\n");
          $re =  clnl(@fgets($con[fopen]));
          if ($re=="[STATUS]")
            {          
            $wr = fwrite($con[fopen], $con[screen_name]."\n");
            $re = clnl(@fgets($con[fopen]));
            if ($re=="[SERVER_RUNNING]".$con[screen_name])
              {
              $game_svr[$key][svr_on] = 1;
              $game_svr[$key][status] = $lng[server_running];
              }
            else
              {
              $game_svr[$key][svr_on] = 0;
              $game_svr[$key][status] = $lng[server_down];            
              }
            $wr = fwrite($con[fopen], "exit\n");
            $re = @fgets($con[fopen]);
            }           
          }
        else
          {
          $game_svr[$key][status] = $lng[error_no_connection];
          $game_svr[$key][svr_on] = -1;          
          }
        fclose($con[fopen]);          
        }
      else
        {
        $game_svr[$key][status] = $lng[error_no_connection];
        $game_svr[$key][svr_on] = -1;
        } 
      }
    }

//
// show the status table
//
function show_status()
  {
  global $game_svr, $lng, $footer_01, $footer_02;
  echo "<p align=center>\n";
  echo "<table style='width: 85%'>\n";
  echo "<tr>\n";
  echo "  <th class=large width='100%'><br>".$lng[found_servers]."<br>".$lng[total_servers]." ".count($game_svr)."<br><br></th>";  
  echo "</tr></table>\n";
  echo "<table style='width: 85%'>\n";
  echo "<tr>\n";  
  echo "  <th width='10%'>".$lng[server_no]."</th>\n";
  echo "  <th width='40%'>".$lng[server_desc]."</th>\n";
  echo "  <th width='30%'>".$lng[server_status]."</th>\n";
  echo "  <th width='10%'>".$lng[server_start]."</th>\n";
  echo "  <th width='10%'>".$lng[server_stop]."</th>\n";
  echo "</tr>\n";

  echo "<form style='align: center;' action='index.php' method='POST'>\n";

  foreach ($game_svr as $key => $con)
    {
    echo "<tr>\n";
    echo "  <td width='10%'>".$key."</th>\n";
    echo "  <td width='40%'>".$con[name]." [".$con[ip]."]</th>\n";
    if ($con[svr_on]==1)
      {
      echo "  <td width='30%' style='background-color: #00C000'>".$con[status]."</td>\n";
      $dis_start = "disabled";
      $dis_stop  = "";
      }
    elseif ($con[svr_on]==-1)
      {
      echo "  <td width='30%' style='background-color: #D00000'>".$con[status]."</td>\n";
      $dis_start = "disabled";
      $dis_stop  = "disabled";      
      }
    else
      {
      echo "  <td width='30%' style='background-color: #D00000'>".$con[status]."</td>\n";
      $dis_start = "";
      $dis_stop  = "disabled";
      }

    echo "  <td width='10%'><button ".$dis_start." style='width: 80px' type='submit' value='".$key."' name='btn_start[]'>".$lng[btn_start]."</button></td>\n";
    echo "  <td width='10%'><button ".$dis_stop." style='width: 80px' type='submit' value='".$key."' name='btn_stop[]' onClick='return disp_confirm(\"".$lng[question_stop].$con[name]."\")'>".$lng[btn_stop]."</button></td>\n";
    echo "</tr>\n";
    }  
  echo "</table>\n";
  echo "<table style='width: 85%'>\n";  
  echo "<tr>\n";
  echo "  <td width='80%'><b>".$lng[update_status]."</b></th>\n";
  echo "  <td width='20%'><button style='width: 200px' type='submit' value='btn_status' name='btn_status'>".$lng[btn_status]."</button></td>\n";
  echo "</tr>\n";

  echo "<tr>\n";
  echo "  <td width='80%'><b>".$lng[all_server_start]."</b></td>\n";
  echo "  <td width='20%'><button style='width: 200px' type='submit' value='btn_start_all' name='btn_start_all'>".$lng[btn_start_all]."</button></td>\n";
  echo "</tr>\n";

  echo "<tr>\n";
  echo "  <td width='80%'><b>".$lng[all_server_stop]."</b></td>\n";
  echo "  <td width='20%'><button style='width: 200px' type='submit' value='btn_stop_all' name='btn_stop_all' onClick='return disp_confirm(\"".$lng[question_stop_all]."\")'>".$lng[btn_stop_all]."</button></td>\n";
  echo "</tr>\n";

  echo "</table>\n";  

  echo "<table style='width: 30%'>\n";
  echo "<tr>\n";
  echo "  <td width='100%'><br/><button style='width: 100px' type='submit' value='btn_logout' name='btn_logout'>LOGOUT</button><br/><br/></td>\n";
  echo "</tr>\n";      
  echo "<tr>\n";
  echo "  <td width='100%'>\n";
  echo "   <a href='http://www.masterzock.de' target='_blank'>CodControl V 0.0.1 by Fraiser 2008</a><br>\n";
  echo "   for <a href='".$footer_01."' target='_blank'>".$footer_02."</a><br>\n";
  echo "  admin[at]masterzock[dot]de<br>\n";  
  echo "</tr>\n";

  echo "</form>";
  echo "</p>\n";  

  }


//
//  main
//

echo "<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.0 Transitional//EN'>\n";
echo "<html\n>";
echo "<head\n>";
echo "<title>Gameserver Start,Stop,Restart and Status for .:FF:._ CLAN</title>\n";
echo "<meta http-equiv='content-type' content='text/html; charset=ISO-8859-1'>\n";
echo "<meta http-equiv='expires' content='0'>\n";
echo "<meta name='author' content=''>\n";
echo "<meta name='description' content=''>\n";
echo "<meta name='keywords' lang='' content=''>\n";
echo "<meta name='generator' content='Fraiser'>\n";
echo "<link rel='stylesheet' type='text/css' href='./style.css'>\n";
echo "<script type='text/javascript'>\n";
echo "  <!-- Java Scripte\n";
echo "  function disp_confirm(txt)\n";
echo "    {\n";
echo "    return confirm(txt)\n";
echo "    }\n";
echo "  -->\n";
echo "</script>\n";

echo "</head>\n";

echo "<body>\n";
echo "<br><p align='center' ><b>".$header_01."<br>\n";
echo $header_02."</b></p><br><hr><br>\n";

//
//  START  the server
//
if (isset($_POST['btn_start']) and $_SESSION['login_okay'])
  {
  $id = $_POST['btn_start'];

    $con = $game_svr[$id[0]];
    $con[fopen] = @fsockopen($encrypt."://".$con[ip], $con[port], $errno, $errstr, 30);
    if ($con[fopen])
      {
      $wr = fwrite($con[fopen], $con[pass]."\n");
      $re =  clnl(@@fgets($con[fopen]));
      if ($re=="[WELCOME]")
        {
        $wr = fwrite($con[fopen], "start\n");
        $re =  clnl(@fgets($con[fopen]));
        if ($re=="[START]")
          {
          // submit screen name
          $wr = fwrite($con[fopen], $con[screen_name]."\n");
          $re = clnl(@fgets($con[fopen]));
          if ($re!="[SERVER_NAME]".$con[screen_name])
            {
            $game_svr[$id[0]][svr_on] = 0;
            $game_svr[$id[0]][status] = $lng[error_screen_name];
  
            $wr = fwrite($con[fopen], "exit\n");
            $re = @fgets($con[fopen]);
            }
          else
            {
            // submit home path
            $wr = fwrite($con[fopen], $con[path]."\n");
            $re = clnl(@fgets($con[fopen]));
            if ($re!="[PATH]".$con[path])
              {
              $game_svr[$id[0]][svr_on] = 0;
              $game_svr[$id[0]][status] = $lng[error_path];
  
              $wr = fwrite($con[fopen], "exit\n");
              $re = @fgets($con[fopen]);
              }
            else
              {
              // submit executable
              $wr = fwrite($con[fopen], $con[executable]."\n");
              $re = clnl(@fgets($con[fopen]));
              if ($re!="[SERVER_EXEC]".$con[executable])
                {
                $game_svr[$id[0]][svr_on] = 0;
                $game_svr[$id[0]][status] = $lng[error_executable];
      
                $wr = fwrite($con[fopen], "exit\n");
                $re = @fgets($con[fopen]);
                }
              else
                {
                // submit start options
                $wr = fwrite($con[fopen], $con[options]."\n");
                $re = clnl(@fgets($con[fopen]));
                if ($re!="[SERVER_OPTIONS]".$con[options])
                  {
                  $game_svr[$id[0]][svr_on] = 0;
                  $game_svr[$id[0]][status] = $lng[error_options];
        
                  $wr = fwrite($con[fopen], "exit\n");
                  $re = @fgets($con[fopen]);
                  }
                }
              }
            }
  
          $wr = fwrite($con[fopen], "exit\n");
          $re = @fgets($con[fopen]);
          }           
        }
      else
        {
        $game_svr[$key][status] = $lng[error_no_connection];
        $game_svr[$key][svr_on] = -1;          
        }        
      fclose($con[fopen]);
      }
    else
      {
      $game_svr[$key][status] = $lng[error_no_connection];
      $game_svr[$key][svr_on] = 0;
      }


  get_status_all();
  show_status();
  }

//
//  START  all server that ar not running
//
elseif (isset($_POST['btn_start_all']) and $_SESSION['login_okay'])
  {
  get_status_all();
  foreach ($game_svr AS $id => $con)
    {
    if ($con[svr_on]==0)
      {
      
      $con[fopen] = @fsockopen($encrypt."://".$con[ip], $con[port], $errno, $errstr, 30);
      if ($con[fopen])
        {
        $wr = fwrite($con[fopen], $con[pass]."\n");
        $re =  clnl(@@fgets($con[fopen]));
        if ($re=="[WELCOME]")
          {
          $wr = fwrite($con[fopen], "start\n");
          $re =  clnl(@fgets($con[fopen]));
          if ($re=="[START]")
            {
            // submit screen name
            $wr = fwrite($con[fopen], $con[screen_name]."\n");
            $re = clnl(@fgets($con[fopen]));
            if ($re!="[SERVER_NAME]".$con[screen_name])
              {
              $game_svr[$id[0]][svr_on] = 0;
              $game_svr[$id[0]][status] = $lng[error_screen_name];
    
              $wr = fwrite($con[fopen], "exit\n");
              $re = @fgets($con[fopen]);
              }
            else
              {
              // submit home path
              $wr = fwrite($con[fopen], $con[path]."\n");
              $re = clnl(@fgets($con[fopen]));
              if ($re!="[PATH]".$con[path])
                {
                $game_svr[$id[0]][svr_on] = 0;
                $game_svr[$id[0]][status] = $lng[error_path];
    
                $wr = fwrite($con[fopen], "exit\n");
                $re = @fgets($con[fopen]);
                }
              else
                {
                // submit executable
                $wr = fwrite($con[fopen], $con[executable]."\n");
                $re = clnl(@fgets($con[fopen]));
                if ($re!="[SERVER_EXEC]".$con[executable])
                  {
                  $game_svr[$id[0]][svr_on] = 0;
                  $game_svr[$id[0]][status] = $lng[error_executable];
        
                  $wr = fwrite($con[fopen], "exit\n");
                  $re = @fgets($con[fopen]);
                  }
                else
                  {
                  // submit start options
                  $wr = fwrite($con[fopen], $con[options]."\n");
                  $re = clnl(@fgets($con[fopen]));
                  if ($re!="[SERVER_OPTIONS]".$con[options])
                    {
                    $game_svr[$id[0]][svr_on] = 0;
                    $game_svr[$id[0]][status] = $lng[error_options];
          
                    $wr = fwrite($con[fopen], "exit\n");
                    $re = @fgets($con[fopen]);
                    }
                  }
                }
              }
    
            $wr = fwrite($con[fopen], "exit\n");
            $re = @fgets($con[fopen]);
            }           
          }
        else
          {
          $game_svr[$key][status] = $lng[error_no_connection];
          $game_svr[$key][svr_on] = -1;          
          }          
        fclose($con[fopen]);
        }
      else
        {
        $game_svr[$key][status] = $lng[error_no_connection];
        $game_svr[$key][svr_on] = 0;
        }
      }
    }
  
  get_status_all();
  show_status();  
  }

//
// STOP  the server
//
elseif (isset($_POST['btn_stop']) and $_SESSION['login_okay'])
  {
  $id = $_POST['btn_stop'];

    $con = $game_svr[$id[0]];
    $con[fopen] = @fsockopen($encrypt."://".$con[ip], $con[port], $errno, $errstr, 30);
    if ($con[fopen])
      {
      $wr = fwrite($con[fopen], $con[pass]."\n");
      $re =  clnl(@@fgets($con[fopen]));
      if ($re=="[WELCOME]")
        {
        $wr = fwrite($con[fopen], "stop\n");
        $re = clnl(@fgets($con[fopen]));
        if ($re=="[STOP]")
          {    
          $wr = fwrite($con[fopen], $con[screen_name]."\n");
          $re = clnl(@fgets($con[fopen]));
          if ($re=="[SERVER_STOPED]".$con[screen_name])
            {
            $game_svr[$id[0]][svr_on] = 0;
            $game_svr[$id[0]][status] = $lng[server_down];
            }
          else
            {
            $game_svr[$id[0]][svr_on] = 1;
            $game_svr[$id[0]][status] = $lng[server_not_stoped];          
            }
              
          $wr = fwrite($con[fopen], "exit\n");
          $re = @fgets($con[fopen]);
          }           
        }
      else
        {
        $game_svr[$key][status] = $lng[error_no_connection];
        $game_svr[$key][svr_on] = -1;          
        }        
      fclose($con[fopen]);
      }
    else
      {
      $game_svr[$key][status] = $lng[error_no_connection];
      $game_svr[$key][svr_on] = 0;
      }

  get_status_all();
  show_status();
  }

//
//  STOP  all server that ar running
//
elseif (isset($_POST['btn_stop_all']) and $_SESSION['login_okay'])
  {
  get_status_all();
  foreach ($game_svr AS $id => $con)
    {
    if ($con[svr_on]==1)
      {
      $con[fopen] = @fsockopen($encrypt."://".$con[ip], $con[port], $errno, $errstr, 30);
      if ($con[fopen])
        {
        $wr = fwrite($con[fopen], $con[pass]."\n");
        $re =  clnl(@@fgets($con[fopen]));
        if ($re=="[WELCOME]")
          {
          $wr = fwrite($con[fopen], "stop\n");
          $re = clnl(@fgets($con[fopen]));
          if ($re=="[STOP]")
            {    
            $wr = fwrite($con[fopen], $con[screen_name]."\n");
            $re = clnl(@fgets($con[fopen]));
            if ($re=="[SERVER_STOPED]".$con[screen_name])
              {
              $game_svr[$id][svr_on] = 0;
              $game_svr[$id][status] = $lng[server_down];
              }
            else
              {
              $game_svr[$id][svr_on] = 1;
              $game_svr[$id][status] = $lng[server_not_stoped];          
              }
                
            $wr = fwrite($con[fopen], "exit\n");
            $re = @fgets($con[fopen]);
            }           
          }
        else
          {
          $game_svr[$key][status] = $lng[error_no_connection];
          $game_svr[$key][svr_on] = -1;          
          }          
        fclose($con[fopen]);
        }
      else
        {
        $game_svr[$key][status] = $lng[error_no_connection];
        $game_svr[$key][svr_on] = 0;
        }
      }
    }
  
  get_status_all();
  show_status();  
  }



//
//  STATUS  update
//
elseif (isset($_POST['btn_status']) and $_SESSION['login_okay'])
  {
  get_status_all();
  show_status();
  }

//
//  logout
//
elseif (isset($_POST['btn_logout']) and $_SESSION['login_okay'])
  {
  session_destroy();
  unset($_SESSION);
  echo "<form action='index.php' method='POST'>\n";
  echo "<p align=center>\n";
  echo "  <input type='text' size='15' name='username'><br>\n";
  echo $lng[username]."<br/>\n";
  echo "  <input type='password' size='15' name='password'><br>\n";
  echo $lng[password]."<br/>\n";
  echo "  <input type='submit' name='btn_login' value='Einloggen'>\n";
  echo "</p>";
  echo "</form>\n";
  }


//
//  login check
//
elseif (isset($_POST['btn_login']))
  {
  if (($_POST['username'] == $usern) and ($_POST['password'] == $pass))
    {
    $_SESSION['username'] = $_POST['username'];
    $_SESSION['login_okay'] = true;
    get_status_all();
    show_status();
    }
  else
    {
    $_SESSION['login_okay'] = false;
    echo "<form action='index.php' method='POST'>\n";
    echo "<p align=center><br/>\n";
    echo $lng[wrong_login]."<br/>\n";
    echo "  <input type='text' size='15' name='username'><br>\n";
    echo $lng[username]."<br/>\n";
    echo "  <input type='password' size='15' name='password'><br>\n";
    echo $lng[password]."<br/>\n";
    echo "  <input type='submit' name='btn_login' value='Einloggen'>\n";
    echo "</p>";
    echo "</form>\n";
    }  
  }

//
// refresh
//
elseif ($_SESSION['login_okay'])
  {
  get_status_all();  
  show_status();
  }

//
// first start show login
//
else
  {
  echo "<form action='index.php' method='POST'>\n";
  echo "<p align=center>\n";
  echo "  <input type='text' size='15' name='username'><br>\n";
  echo $lng[username]."<br/>\n";
  echo "  <input type='password' size='15' name='password'><br>\n";
  echo $lng[password]."<br/>\n";
  echo "  <input type='submit' name='btn_login' value='Einloggen'>\n";
  echo "</p>";
  echo "</form>\n";
  }

echo "</body></html>\n";
?>
